#!/usr/bin/perl
use Date::Calc qw(:all);

$Dd="-1";
$DEBUG=0;

@users=`ls /home`;
@tmdausers=();
foreach $i (@users){
  chomp($i);
  if(-f "/home/$i/.procmailrc"){
    $x=`grep '^INCLUDERC=\$PMDIR/rc.tmda' /home/$i/.procmailrc  `;
    if($x){
      push(@tmdausers,$i)
    }
  }
}


&gettime;

$dow=Day_of_Week($year,$month,$day);
$dow=Day_of_Week_Abbreviation($dow);
$string=sprintf("%.3s %d",Month_to_Text($month),$day);
$tmdadate=$dow . " " . $string;
print "TMDA date: $tmdadate\n" if $DEBUG;

($yestyear,$yestmonth,$yest)=Add_Delta_Days($year,$month,$day,$Dd);
$yestmonth = sprintf "%.2d", $yestmonth;

$yestdow=Day_of_Week($yestyear,$yestmonth,$yest);
$yestdow=Day_of_Week_Abbreviation($yestdow);
$string=sprintf("%.3s %d",Month_to_Text($yestmonth),$yest);
$yesttmdadate=$yestdow . " " . $string;
print "TMDA yestdate: $yesttmdadate\n" if $DEBUG;

$c=0;
$gotit=0;
$pendings=0;
$totalpendings=0;
foreach $i (@tmdausers){
  # get # pendings for this dude
  $pendingdir="/home/$i/.tmda/pending/*.msg";
  @pendarray=glob("$pendingdir");
  $pendings=$#pendarray+1;
  print "User $i has $pendings pending messages.\n" if $DEBUG;
  $totalpendings=$totalpendings+$pendings;

  $log="/home/$i/.tmda/logs/$yestyear$yestmonth-incoming";
  open(L,"<$log")||die "Can't read log: $!";
  while(<L>){
    chomp($_);
    if ($_ !~/:/){   # if line does not have colon, is prolly blank
       next;
    }
    if($_=~/^Date: $yesttmdadate/){
      ($key,$value)=split(/:/,$_,2);
      $loggy[$c]{$key}=$value;
      print "got $c $_ $i\n" if $DEBUG;
      $gotit=1;
      next;
    }
    if(($_=~/^Actn:/) && ($gotit==1)){
      ($key,$value)=split(/:/,$_,2);
      $loggy[$c]{$key}=$value;
      print "got $c $_\n" if $DEBUG;
      $c++;
      $gotit=0;
      next;
    }
  }  # end some user's loop
  close(L);
}

$oks=0; $noreplys=0; $delivers=0; $confirmactincs=0; $confirmspecs=0; 
$confirmpends=0; $confirmappends=0; $confirmaccs=0; $drops=0;

$x=0;
foreach $href (@loggy){
     print "$x\n" if $DEBUG;
     $x++;
  for $key (keys %$href){
    $value=$href->{$key};
    print "HASH: $key $value\n" if $DEBUG;

    if($value =~ /OK/){
      $oks++;
    }elsif($value =~ /DROP/){
      $drops++;
    }elsif($value =~ /NOREPLY/){
      $noreplys++;
    }elsif($value =~ /DELIVER/){
      $delivers++;
    }elsif($value =~ /CONFIRM action_incoming/){
      $confirmactincs++;
    }elsif($value =~ /CONFIRM pending/){
      $confirmpends++;
    }elsif($value =~ /CONFIRM accept/){
      $confirmaccs++;
    }elsif($value =~ /CONFIRM_APPEND/){
      $confirmappends++;
    }elsif($value =~ /CONFIRM/){    #special confirms from filter
      $confirmspecs++;
    }

  }
}


$actions=$#loggy+1;
$processed=$oks+$drops+$delivers+$noreplys+$confirmactincs+$confirmspecs;

$ppl=$#tmdausers+1;

 #!/usr/bin/perl
$pmlog="/root/.procmail/log";
$pmkilled=0;
$attachkilled=0;
open(F,"<$pmlog");
while(<F>){
  if($_ =~ /Folder: \/dev\/null/){
    $pmkilled++;
  }
  if($_ =~ /Folder: \/root\/badmail/){
    $attachkilled++;
  }
}
close(F);
`/usr/local/bin/mailstat $pmlog`;
 
# $pmkilled=`grep \'Folder: /dev/null' $pmlog\' | wc -l`;


print "Rupture SPAM Stats Report for $yesttmdadate $yestyear\n\n";
print "Procmail:\n";
printf "%4d kills.\n", $pmkilled;
printf "%4d executable attachments quarantined.\n", $attachkilled;
print "\n";
print "TMDA:\n";
printf "%4d users.\n", $ppl;
printf "%4d currently pending messages.\n", $totalpendings;
printf "%4d actions.\n", $actions ;
printf "%4d pieces of email processed.\n", $processed ;
printf "%4d OKs.\n", $oks ;
printf "%4d DROPs.\n", $drops; 
printf "%4d NOREPLYs.\n", $noreplys;
printf "%4d DELIVERs.\n", $delivers ;
printf "%4d CONFIRM action_incomings.\n", $confirmactincs ;
printf "%4d CONFIRM (special)s.\n", $confirmspecs;
printf "%4d CONFIRM pendings.\n", $confirmpends ;
printf "%4d CONFIRM accepts.\n", $confirmaccs;
printf "%4d CONFIRM_APPENDs.\n", $confirmappends ;

print "\nBYE~!\n\n";


sub gettime{
   ($year,$month,$day,$hour,$min,$sec) = Today_and_Now();

   $sec = sprintf "%.2d", $sec;
   $min = sprintf "%.2d", $min;
   $hour = sprintf "%.2d", $hour;
   $day = sprintf "%.2d", $day;
   $month = sprintf "%.2d", $month;

   $t = $year . $month . $day . " " . $hour . ":" . $min . ":" . $sec;
   $date = $year . $month . $day;

   return ($t,$date,$year,$month,$day);
}
